OGRE: Ogre::ParticleEmitter Class Reference

| OGRE 2.2.4 Object-Oriented Graphics Rendering Engine

Public Types | Public Member Functions | Static Public Member Functions | Public Attributes | List of all members
Ogre::ParticleEmitter Class Referenceabstract
Core » Effects

Abstract class defining the interface to be implemented by particle emitters. More...

`#include <OgreParticleEmitter.h>`

Inheritance diagram for Ogre::ParticleEmitter:
[legend]

## Public Types
enum | ParticleType { Visual, Emitter }
| Type of particle. More...

## Public Member Functions
| ParticleEmitter (ParticleSystem *psys)
virtual | ~ParticleEmitter ()
| Virtual destructor essential. More...
virtual unsigned short | _getEmissionCount (Real timeElapsed)=0
| Gets the number of particles which this emitter would like to emit based on the time elapsed. More...
virtual void | _initParticle (Particle *pParticle)
| Initialises a particle based on the emitter's approach and parameters. More...
void | _notifyOwner (ParticleSystem *owner)
| Internal method for notifying the particle of it's owner. More...
void | _notifyVisualData (ParticleVisualData *vis)
| Internal method for notifying the particle of it's optional visual data. More...
virtual void | copyParametersTo (StringInterface *dest) const
| Method for copying this object's parameters to another object. More...
virtual const Radian & | getAngle (void) const
| Returns the maximum angle which the initial particle direction can deviate from the emitters base direction. More...
virtual const ColourValue & | getColour (void) const
| Gets the colour of particles to be emitted. More...
virtual const ColourValue & | getColourRangeEnd (void) const
| Gets the maximum colour of particles to be emitted. More...
virtual const ColourValue & | getColourRangeStart (void) const
| Gets the minimum colour of particles to be emitted. More...
virtual const Vector3 & | getDirection (void) const
| Returns the base direction of the emitter. More...
virtual const Vector3 & | getDirPositionReference () const
| Returns the position reference to generate direction of emitted particles. More...
virtual bool | getDirPositionReferenceEnabled () const
| Returns whether direction or position reference is used. More...
virtual Real | getDuration (void) const
| Gets the duration of the emitter from when it is created or re-enabled. More...
virtual Real | getEmissionRate (void) const
| Returns the emission rate set for this emitter. More...
const String & | getEmittedEmitter (void) const
| Returns the name of the emitter to be emitted. More...
virtual bool | getEnabled (void) const
| Gets the flag indicating if this emitter is enabled or not. More...
virtual Real | getMaxDuration (void) const
| Gets the maximum duration of this emitter in seconds (see setDuration for more details) More...
virtual Real | getMaxParticleVelocity (void) const
| Returns the maximum particle velocity. More...
virtual Real | getMaxRepeatDelay (void) const
| Gets the maximum duration of this emitter in seconds (see setRepeatDelay for more details) More...
virtual Real | getMaxTimeToLive (void) const
| Gets the maximum time each particle will live for. More...
virtual Real | getMinDuration (void) const
| Gets the minimum duration of this emitter in seconds (see setDuration for more details) More...
virtual Real | getMinParticleVelocity (void) const
| Returns the minimum particle velocity. More...
virtual Real | getMinRepeatDelay (void) const
| Gets the minimum duration of this emitter in seconds (see setRepeatDelay for more details) More...
virtual Real | getMinTimeToLive (void) const
| Gets the minimum time each particle will live for. More...
const String & | getName (void) const
| Returns the name of the emitter. More...
Real | getOwnHeight (void) const
| Retrieves the particle's personal width, if hasOwnDimensions is true. More...
Real | getOwnWidth (void) const
| Retrieves the particle's personal width, if hasOwnDimensions is true. More...
ParamDictionary * | getParamDictionary (void)
| Retrieves the parameter dictionary for this class. More...
const ParamDictionary * | getParamDictionary (void) const
virtual String | getParameter (const String &name) const
| Generic parameter retrieval method. More...
const ParameterList & | getParameters (void) const
| Retrieves a list of parameters valid for this object. More...
virtual Real | getParticleVelocity (void) const
| Returns the initial velocity of particles emitted. More...
virtual const Vector3 & | getPosition (void) const
| Returns the position of this emitter relative to the center of the particle system. More...
virtual Real | getRepeatDelay (void) const
| Gets the duration of the emitter from when it is created or re-enabled. More...
const Radian & | getRotation (void) const
virtual Real | getStartTime (void) const
| Gets the start time of the emitter. More...
virtual Real | getTimeToLive (void) const
| Gets the time each particle will live for. More...
const String & | getType (void) const
| Returns the name of the type of emitter. More...
virtual const Vector3 & | getUp (void) const
| Returns the up vector of the emitter. More...
ParticleVisualData * | getVisualData (void) const
| Get the optional visual data associated with the class. More...
bool | hasOwnDimensions (void) const
| Returns true if this particle deviates from the ParticleSystem's default dimensions (i.e. More...
virtual bool | isEmitted (void) const
| Return true if the emitter is emitted by another emitter. More...
void | operator delete (void *ptr)
void | operator delete (void *ptr, const char *, int, const char *)
void | operator delete (void *ptr, void *)
void | operator delete[] (void *ptr)
void | operator delete[] (void *ptr, const char *, int, const char *)
void * | operator new (size_t sz)
void * | operator new (size_t sz, const char *file, int line, const char *func)
| operator new, with debug line info More...
void * | operator new (size_t sz, void *ptr)
| placement operator new More...
void * | operator new[] (size_t sz)
void * | operator new[] (size_t sz, const char *file, int line, const char *func)
| array operator new, with debug line info More...
void | resetDimensions (void)
| Utility method to reset this particle. More...
virtual void | setAngle (const Radian &angle)
| Sets the maximum angle away from the emitter direction which particle will be emitted. More...
virtual void | setColour (const ColourValue &colour)
| Sets the initial colour of particles emitted. More...
virtual void | setColour (const ColourValue &colourStart, const ColourValue &colourEnd)
| Sets the range of colours for emitted particles. More...
virtual void | setColourRangeEnd (const ColourValue &colour)
| Sets the maximum colour of particles to be emitted. More...
virtual void | setColourRangeStart (const ColourValue &colour)
| Sets the minimum colour of particles to be emitted. More...
void | setDimensions (Real width, Real height)
| Sets the width and height for this particle. More...
virtual void | setDirection (const Vector3 &direction)
| Sets the direction of the emitter. More...
virtual void | setDirPositionReference (const Vector3 &position, bool enable)
| Sets the direction of the emitter. More...
virtual void | setDuration (Real duration)
| Sets the duration of the emitter. More...
virtual void | setDuration (Real min, Real max)
| Sets the range of random duration for this emitter. More...
virtual void | setEmissionRate (Real particlesPerSecond)
| Sets the emission rate for this emitter. More...
virtual void | setEmitted (bool emitted)
| Set the indication (true/false) to indicate that the emitter is emitted by another emitter. More...
virtual void | setEmittedEmitter (const String &emittedEmitter)
| Sets the name of the emitter to be emitted. More...
virtual void | setEnabled (bool enabled)
| Sets whether or not the emitter is enabled. More...
virtual void | setMaxDuration (Real max)
| Sets the maximum duration of this emitter in seconds (see setDuration for more details) More...
virtual void | setMaxParticleVelocity (Real max)
| Returns the maximum particle velocity. More...
virtual void | setMaxRepeatDelay (Real max)
| Sets the maximum duration of this emitter in seconds (see setRepeatDelay for more details) More...
virtual void | setMaxTimeToLive (Real max)
| Sets the maximum time each particle will live for. More...
virtual void | setMinDuration (Real min)
| Sets the minimum duration of this emitter in seconds (see setDuration for more details) More...
virtual void | setMinParticleVelocity (Real min)
| Returns the minimum particle velocity. More...
virtual void | setMinRepeatDelay (Real min)
| Sets the minimum duration of this emitter in seconds (see setRepeatDelay for more details) More...
virtual void | setMinTimeToLive (Real min)
| Sets the minimum time each particle will live for. More...
virtual void | setName (const String &newName)
| Sets the name of the emitter. More...
virtual bool | setParameter (const String &name, const String &value)
| Generic parameter setting method. More...
virtual void | setParameterList (const NameValuePairList &paramList)
| Generic multiple parameter setting method. More...
virtual void | setParticleVelocity (Real min, Real max)
| Sets the initial velocity range of particles emitted. More...
virtual void | setParticleVelocity (Real speed)
| Sets the initial velocity of particles emitted. More...
virtual void | setPosition (const Vector3 &pos)
| Sets the position of this emitter relative to the particle system center. More...
virtual void | setRepeatDelay (Real duration)
| Sets the time between repeats of the emitter. More...
virtual void | setRepeatDelay (Real min, Real max)
| Sets the range of random duration for this emitter. More...
void | setRotation (const Radian &rad)
| Sets the current rotation. More...
virtual void | setStartTime (Real startTime)
| Sets the 'start time' of this emitter. More...
virtual void | setTimeToLive (Real minTtl, Real maxTtl)
| Sets the range of lifetime for particles emitted. More...
virtual void | setTimeToLive (Real ttl)
| Sets the lifetime of all particles emitted. More...
virtual void | setUp (const Vector3 &up)
| Sets the notional up vector of the emitter. More...

## Static Public Member Functions
static void | cleanupDictionary ()
| Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g. More...

## Public Attributes
ColourValue | mColour
| Current colour. More...
Real | mHeight
| Personal height if mOwnDimensions == true. More...
bool | mOwnDimensions
| Does this particle have it's own dimensions? More...
ParticleType | mParticleType
| Determines the type of particle. More...
Radian | mRotation
| Current rotation value. More...
Radian | mRotationSpeed
| Speed of rotation in radians/sec. More...
Real | mTimeToLive
| Time to live, number of seconds left of particles natural life. More...
Real | mTotalTimeToLive
| Total Time to live, number of seconds of particles natural life. More...
Real | mWidth
| Personal width if mOwnDimensions == true. More...

## Detailed Description

Abstract class defining the interface to be implemented by particle emitters.

Remarks
  Particle emitters are the sources of particles in a particle system. This class defines the ParticleEmitter interface, and provides a basic implementation for tasks which most emitters will do (these are of course overridable). Particle emitters can be grouped into types, e.g. 'point' emitters, 'box' emitters etc; each type will create particles with a different starting point, direction and velocity (although within the types you can configure the ranges of these parameters).

  Because there are so many types of emitters you could use, OGRE chooses not to dictate the available types. It comes with some in-built, but allows plugins or applications to extend the emitter types available. This is done by subclassing ParticleEmitter to have the appropriate emission behaviour you want, and also creating a subclass of ParticleEmitterFactory which is responsible for creating instances of your new emitter type. You register this factory with the ParticleSystemManager using addEmitterFactory, and from then on emitters of this type can be created either from code or through text particle scripts by naming the type.

  This same approach is used for ParticleAffectors (which modify existing particles per frame). This means that OGRE is particularly flexible when it comes to creating particle system effects, with literally infinite combinations of emitter and affector types, and parameters within those types.

## Member Enumeration Documentation

## ◆ ParticleType

enum Ogre::Particle::ParticleType
| inherited

Type of particle.

Enumerator
Visual |
Emitter |

## Constructor & Destructor Documentation

## ◆ ParticleEmitter()

Ogre::ParticleEmitter::ParticleEmitter | ( | ParticleSystem * | psys | ) |

## ◆ ~ParticleEmitter()

virtual Ogre::ParticleEmitter::~ParticleEmitter | ( |  | ) |
| virtual

Virtual destructor essential.

## Member Function Documentation

## ◆ _getEmissionCount()

virtual unsigned short Ogre::ParticleEmitter::_getEmissionCount | ( | Real | timeElapsed | ) |
| pure virtual

Gets the number of particles which this emitter would like to emit based on the time elapsed.

Remarks
  For efficiency the emitter does not actually create new Particle instances (these are reused by the ParticleSystem as existing particles 'die'). The implementation for this method must return the number of particles the emitter would like to emit given the number of seconds which have elapsed (passed in as a parameter).

  Based on the return value from this method, the ParticleSystem class will call _initParticle once for each particle it chooses to allow to be emitted by this emitter. The emitter should not track these _initParticle calls, it should assume all emissions requested were made (even if they could not be because of particle quotas).

## ◆ _initParticle()

virtual void Ogre::ParticleEmitter::_initParticle | ( | Particle * | pParticle | ) |
| inlinevirtual

Initialises a particle based on the emitter's approach and parameters.

Remarks
  See the _getEmissionCount method for details of why there is a separation between 'requested' emissions and actual initialised particles.

Parameters

  pParticle | Pointer to a particle which must be initialised based on how this emitter starts particles. This is passed as a pointer rather than being created by the emitter so the ParticleSystem can reuse Particle instances, and can also set defaults itself.

References Ogre::Particle::resetDimensions().

## ◆ _notifyOwner()

void Ogre::Particle::_notifyOwner | ( | ParticleSystem * | owner | ) |
| inherited

Internal method for notifying the particle of it's owner.

## ◆ _notifyVisualData()

void Ogre::Particle::_notifyVisualData | ( | ParticleVisualData * | vis | ) |
| inlineinherited

Internal method for notifying the particle of it's optional visual data.

## ◆ cleanupDictionary()

static void Ogre::StringInterface::cleanupDictionary | ( |  | ) |
| staticinherited

Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g.

MaterialManager) initializes.

## ◆ copyParametersTo()

virtual void Ogre::StringInterface::copyParametersTo | ( | StringInterface * | dest | ) | const
| inlinevirtualinherited

Method for copying this object's parameters to another object.

Remarks
  This method takes the values of all the object's parameters and tries to set the same values on the destination object. This provides a completely type independent way to copy parameters to other objects. Note that because of the String manipulation involved, this should not be regarded as an efficient process and should be saved for times outside of the rendering loop.

  Any unrecognised parameters will be ignored as with setParameter method.

Parameters

  dest | Pointer to object to have it's parameters set the same as this object.

References Ogre::StringInterface::setParameter().

## ◆ getAngle()

virtual const Radian& Ogre::ParticleEmitter::getAngle | ( | void |  | ) | const
| virtual

Returns the maximum angle which the initial particle direction can deviate from the emitters base direction.

## ◆ getColour()

virtual const ColourValue& Ogre::ParticleEmitter::getColour | ( | void |  | ) | const
| virtual

Gets the colour of particles to be emitted.

## ◆ getColourRangeEnd()

virtual const ColourValue& Ogre::ParticleEmitter::getColourRangeEnd | ( | void |  | ) | const
| virtual

Gets the maximum colour of particles to be emitted.

## ◆ getColourRangeStart()

virtual const ColourValue& Ogre::ParticleEmitter::getColourRangeStart | ( | void |  | ) | const
| virtual

Gets the minimum colour of particles to be emitted.

## ◆ getDirection()

virtual const Vector3& Ogre::ParticleEmitter::getDirection | ( | void |  | ) | const
| virtual

Returns the base direction of the emitter.

## ◆ getDirPositionReference()

virtual const Vector3& Ogre::ParticleEmitter::getDirPositionReference | ( |  | ) | const
| virtual

Returns the position reference to generate direction of emitted particles.

## ◆ getDirPositionReferenceEnabled()

virtual bool Ogre::ParticleEmitter::getDirPositionReferenceEnabled | ( |  | ) | const
| virtual

Returns whether direction or position reference is used.

## ◆ getDuration()

virtual Real Ogre::ParticleEmitter::getDuration | ( | void |  | ) | const
| virtual

Gets the duration of the emitter from when it is created or re-enabled.

## ◆ getEmissionRate()

virtual Real Ogre::ParticleEmitter::getEmissionRate | ( | void |  | ) | const
| virtual

Returns the emission rate set for this emitter.

## ◆ getEmittedEmitter()

const String& Ogre::ParticleEmitter::getEmittedEmitter | ( | void |  | ) | const

Returns the name of the emitter to be emitted.

## ◆ getEnabled()

virtual bool Ogre::ParticleEmitter::getEnabled | ( | void |  | ) | const
| virtual

Gets the flag indicating if this emitter is enabled or not.

## ◆ getMaxDuration()

virtual Real Ogre::ParticleEmitter::getMaxDuration | ( | void |  | ) | const
| virtual

Gets the maximum duration of this emitter in seconds (see setDuration for more details)

## ◆ getMaxParticleVelocity()

virtual Real Ogre::ParticleEmitter::getMaxParticleVelocity | ( | void |  | ) | const
| virtual

Returns the maximum particle velocity.

## ◆ getMaxRepeatDelay()

virtual Real Ogre::ParticleEmitter::getMaxRepeatDelay | ( | void |  | ) | const
| virtual

Gets the maximum duration of this emitter in seconds (see setRepeatDelay for more details)

## ◆ getMaxTimeToLive()

virtual Real Ogre::ParticleEmitter::getMaxTimeToLive | ( | void |  | ) | const
| virtual

Gets the maximum time each particle will live for.

## ◆ getMinDuration()

virtual Real Ogre::ParticleEmitter::getMinDuration | ( | void |  | ) | const
| virtual

Gets the minimum duration of this emitter in seconds (see setDuration for more details)

## ◆ getMinParticleVelocity()

virtual Real Ogre::ParticleEmitter::getMinParticleVelocity | ( | void |  | ) | const
| virtual

Returns the minimum particle velocity.

## ◆ getMinRepeatDelay()

virtual Real Ogre::ParticleEmitter::getMinRepeatDelay | ( | void |  | ) | const
| virtual

Gets the minimum duration of this emitter in seconds (see setRepeatDelay for more details)

## ◆ getMinTimeToLive()

virtual Real Ogre::ParticleEmitter::getMinTimeToLive | ( | void |  | ) | const
| virtual

Gets the minimum time each particle will live for.

## ◆ getName()

const String& Ogre::ParticleEmitter::getName | ( | void |  | ) | const

Returns the name of the emitter.

## ◆ getOwnHeight()

Real Ogre::Particle::getOwnHeight | ( | void |  | ) | const
| inlineinherited

Retrieves the particle's personal width, if hasOwnDimensions is true.

## ◆ getOwnWidth()

Real Ogre::Particle::getOwnWidth | ( | void |  | ) | const
| inlineinherited

Retrieves the particle's personal width, if hasOwnDimensions is true.

## ◆ getParamDictionary() [1/2]

ParamDictionary* Ogre::StringInterface::getParamDictionary | ( | void |  | ) |
| inlineinherited

Retrieves the parameter dictionary for this class.

Remarks
  Only valid to call this after createParamDictionary.

Returns
  Pointer to ParamDictionary shared by all instances of this class which you can add parameters to, retrieve parameters etc.

## ◆ getParamDictionary() [2/2]

const ParamDictionary* Ogre::StringInterface::getParamDictionary | ( | void |  | ) | const
| inlineinherited

## ◆ getParameter()

virtual String Ogre::StringInterface::getParameter | ( | const String & | name | ) | const
| inlinevirtualinherited

Generic parameter retrieval method.

Remarks
  Call this method with the name of a parameter to retrieve a string-format value of the parameter in question. If in doubt, check the parameter definition in the list returned from getParameters for the type of this parameter. If you like you can use StringConverter to convert this string back into a native type.

Parameters

  name | The name of the parameter to get

Returns
  String value of parameter, blank if not found

References Ogre::ParamCommand::doGet().

## ◆ getParameters()

const ParameterList& Ogre::StringInterface::getParameters | ( | void |  | ) | const
| inherited

Retrieves a list of parameters valid for this object.

Returns
  A reference to a static list of ParameterDef objects.

## ◆ getParticleVelocity()

virtual Real Ogre::ParticleEmitter::getParticleVelocity | ( | void |  | ) | const
| virtual

Returns the initial velocity of particles emitted.

## ◆ getPosition()

virtual const Vector3& Ogre::ParticleEmitter::getPosition | ( | void |  | ) | const
| virtual

Returns the position of this emitter relative to the center of the particle system.

## ◆ getRepeatDelay()

virtual Real Ogre::ParticleEmitter::getRepeatDelay | ( | void |  | ) | const
| virtual

Gets the duration of the emitter from when it is created or re-enabled.

## ◆ getRotation()

const Radian& Ogre::Particle::getRotation | ( | void |  | ) | const
| inlineinherited

## ◆ getStartTime()

virtual Real Ogre::ParticleEmitter::getStartTime | ( | void |  | ) | const
| virtual

Gets the start time of the emitter.

## ◆ getTimeToLive()

virtual Real Ogre::ParticleEmitter::getTimeToLive | ( | void |  | ) | const
| virtual

Gets the time each particle will live for.

## ◆ getType()

const String& Ogre::ParticleEmitter::getType | ( | void |  | ) | const
| inline

Returns the name of the type of emitter.

Remarks
  This property is useful for determining the type of emitter procedurally so another can be created.

## ◆ getUp()

virtual const Vector3& Ogre::ParticleEmitter::getUp | ( | void |  | ) | const
| virtual

Returns the up vector of the emitter.

## ◆ getVisualData()

ParticleVisualData* Ogre::Particle::getVisualData | ( | void |  | ) | const
| inlineinherited

Get the optional visual data associated with the class.

## ◆ hasOwnDimensions()

bool Ogre::Particle::hasOwnDimensions | ( | void |  | ) | const
| inlineinherited

Returns true if this particle deviates from the ParticleSystem's default dimensions (i.e.

if the particle::setDimensions method has been called for this instance).

See also
  particle::setDimensions

## ◆ isEmitted()

virtual bool Ogre::ParticleEmitter::isEmitted | ( | void |  | ) | const
| virtual

Return true if the emitter is emitted by another emitter.

## ◆ operator delete() [1/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr | ) |
| inlineinherited

## ◆ operator delete() [2/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |
| ) |  |
| inlineinherited

## ◆ operator delete() [3/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | void * |
| ) |  |
| inlineinherited

## ◆ operator delete[]() [1/2]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr | ) |
| inlineinherited

## ◆ operator delete[]() [2/2]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |
| ) |  |
| inlineinherited

## ◆ operator new() [1/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz | ) |
| inlineinherited

## ◆ operator new() [2/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func
| ) |  |
| inlineinherited

operator new, with debug line info

## ◆ operator new() [3/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | void * | ptr
| ) |  |
| inlineinherited

placement operator new

## ◆ operator new[]() [1/2]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz | ) |
| inlineinherited

## ◆ operator new[]() [2/2]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func
| ) |  |
| inlineinherited

array operator new, with debug line info

## ◆ resetDimensions()

void Ogre::Particle::resetDimensions | ( | void |  | ) |
| inherited

Utility method to reset this particle.

Referenced by _initParticle().

## ◆ setAngle()

virtual void Ogre::ParticleEmitter::setAngle | ( | const Radian & | angle | ) |
| virtual

Sets the maximum angle away from the emitter direction which particle will be emitted.

Remarks
  Whilst the direction property defines the general direction of emission for particles, this property defines how far the emission angle can deviate away from this base direction. This allows you to create a scatter effect - if set to 0, all particles will be emitted exactly along the emitters direction vector, whereas if you set it to 180 degrees or more, particles will be emitted in a sphere, i.e. in all directions.

Parameters

  angle | Maximum angle which initial particle direction can deviate from the emitter base direction vector.

## ◆ setColour() [1/2]

virtual void Ogre::ParticleEmitter::setColour | ( | const ColourValue & | colour | ) |
| virtual

Sets the initial colour of particles emitted.

Remarks
  Particles have an initial colour on emission which the emitter sets. This method sets this colour. See the alternate version of this method which takes 2 colours in order to establish a range of colours to be assigned to particles.

Parameters

  colour | The colour which all particles will be given on emission.

## ◆ setColour() [2/2]

virtual void Ogre::ParticleEmitter::setColour | ( | const ColourValue & | colourStart,
|  | const ColourValue & | colourEnd
| ) |  |
| virtual

Sets the range of colours for emitted particles.

Remarks
  Particles have an initial colour on emission which the emitter sets. This method sets the range of this colour. See the alternate version of this method which takes a single colour in order to set a constant colour for all particles. Emitters may choose to randomly assign a colour in this range, or may use some other method to vary the colour.

Parameters

  colourStart | The start of the colour range
  colourEnd | The end of the colour range

## ◆ setColourRangeEnd()

virtual void Ogre::ParticleEmitter::setColourRangeEnd | ( | const ColourValue & | colour | ) |
| virtual

Sets the maximum colour of particles to be emitted.

## ◆ setColourRangeStart()

virtual void Ogre::ParticleEmitter::setColourRangeStart | ( | const ColourValue & | colour | ) |
| virtual

Sets the minimum colour of particles to be emitted.

## ◆ setDimensions()

void Ogre::Particle::setDimensions | ( | Real | width,
|  | Real | height
| ) |  |
| inherited

Sets the width and height for this particle.

Remarks
  Note that it is most efficient for every particle in a ParticleSystem to have the same dimensions. If you choose to alter the dimensions of an individual particle the set will be less efficient. Do not call this method unless you really need to have different particle dimensions within the same set. Otherwise just call the ParticleSystem::setDefaultDimensions method instead.

## ◆ setDirection()

virtual void Ogre::ParticleEmitter::setDirection | ( | const Vector3 & | direction | ) |
| virtual

Sets the direction of the emitter.

Remarks
  Most emitters will have a base direction in which they emit particles (those which emit in all directions will ignore this parameter). They may not emit exactly along this vector for every particle, many will introduce a random scatter around this vector using the angle property.

Note
  This resets the up vector.

Parameters

  direction | The base direction for particles emitted.

## ◆ setDirPositionReference()

virtual void Ogre::ParticleEmitter::setDirPositionReference | ( | const Vector3 & | position,
|  | bool | enable
| ) |  |
| virtual

Sets the direction of the emitter.

Some particle effects need to emit particles in many random directions, but still following some rules; like not having them collide against each other. Very useful for explosions and implosions (when velocity is negative)

Note
  Although once enabled mDirPositionRef will supersede mDirection; calling setDirection() may still be needed to setup a custom up vector.

Parameters

  position | The reference position in which the direction of the particles will be calculated from, also taking into account the particle's position at the time of emission.
  enable | True to use mDirPositionRef, false to use the default behaviour with mDirection

## ◆ setDuration() [1/2]

virtual void Ogre::ParticleEmitter::setDuration | ( | Real | duration | ) |
| virtual

Sets the duration of the emitter.

Remarks
  By default emitters run indefinitely (unless you manually disable them). By setting this parameter, you can make an emitter turn off on it's own after a set number of seconds. It will then remain disabled until either setEnabled(true) is called, or if the 'repeatAfter' parameter has been set it will also repeat after a number of seconds.

  Also see the alternative version of this method which allows you to set a min and max duration for a random variable duration.

Parameters

  duration | The duration in seconds.

## ◆ setDuration() [2/2]

virtual void Ogre::ParticleEmitter::setDuration | ( | Real | min,
|  | Real | max
| ) |  |
| virtual

Sets the range of random duration for this emitter.

Remarks
  By default emitters run indefinitely (unless you manually disable them). By setting this parameter, you can make an emitter turn off on it's own after a random number of seconds. It will then remain disabled until either setEnabled(true) is called, or if the 'repeatAfter' parameter has been set it will also repeat after a number of seconds.

  Also see the alternative version of this method which allows you to set a constant duration.

Parameters

  min | The minimum duration in seconds.
  max | The minimum duration in seconds.

## ◆ setEmissionRate()

virtual void Ogre::ParticleEmitter::setEmissionRate | ( | Real | particlesPerSecond | ) |
| virtual

Sets the emission rate for this emitter.

Remarks
  This method tells the emitter how many particles per second should be emitted. The emitter subclass does not have to emit these in a continuous burst - this is a relative parameter and the emitter may choose to emit all of the second's worth of particles every half-second for example. This is controlled by the emitter's getEmissionCount method.

  Also, if the ParticleSystem's particle quota is exceeded, not all the particles requested may be actually emitted.

Parameters

  particlesPerSecond | The number of particles to be emitted every second.

## ◆ setEmitted()

virtual void Ogre::ParticleEmitter::setEmitted | ( | bool | emitted | ) |
| virtual

Set the indication (true/false) to indicate that the emitter is emitted by another emitter.

## ◆ setEmittedEmitter()

virtual void Ogre::ParticleEmitter::setEmittedEmitter | ( | const String & | emittedEmitter | ) |
| virtual

Sets the name of the emitter to be emitted.

## ◆ setEnabled()

virtual void Ogre::ParticleEmitter::setEnabled | ( | bool | enabled | ) |
| virtual

Sets whether or not the emitter is enabled.

Remarks
  You can turn an emitter off completely by setting this parameter to false.

## ◆ setMaxDuration()

virtual void Ogre::ParticleEmitter::setMaxDuration | ( | Real | max | ) |
| virtual

Sets the maximum duration of this emitter in seconds (see setDuration for more details)

## ◆ setMaxParticleVelocity()

virtual void Ogre::ParticleEmitter::setMaxParticleVelocity | ( | Real | max | ) |
| virtual

Returns the maximum particle velocity.

## ◆ setMaxRepeatDelay()

virtual void Ogre::ParticleEmitter::setMaxRepeatDelay | ( | Real | max | ) |
| virtual

Sets the maximum duration of this emitter in seconds (see setRepeatDelay for more details)

## ◆ setMaxTimeToLive()

virtual void Ogre::ParticleEmitter::setMaxTimeToLive | ( | Real | max | ) |
| virtual

Sets the maximum time each particle will live for.

Must be non-negative!

## ◆ setMinDuration()

virtual void Ogre::ParticleEmitter::setMinDuration | ( | Real | min | ) |
| virtual

Sets the minimum duration of this emitter in seconds (see setDuration for more details)

## ◆ setMinParticleVelocity()

virtual void Ogre::ParticleEmitter::setMinParticleVelocity | ( | Real | min | ) |
| virtual

Returns the minimum particle velocity.

## ◆ setMinRepeatDelay()

virtual void Ogre::ParticleEmitter::setMinRepeatDelay | ( | Real | min | ) |
| virtual

Sets the minimum duration of this emitter in seconds (see setRepeatDelay for more details)

## ◆ setMinTimeToLive()

virtual void Ogre::ParticleEmitter::setMinTimeToLive | ( | Real | min | ) |
| virtual

Sets the minimum time each particle will live for.

Must be non-negative!

## ◆ setName()

virtual void Ogre::ParticleEmitter::setName | ( | const String & | newName | ) |
| virtual

Sets the name of the emitter.

## ◆ setParameter()

virtual bool Ogre::StringInterface::setParameter | ( | const String & | name,
|  | const String & | value
| ) |  |
| virtualinherited

Generic parameter setting method.

Remarks
  Call this method with the name of a parameter and a string version of the value to set. The implementor will convert the string to a native type internally. If in doubt, check the parameter definition in the list returned from StringInterface::getParameters.

Parameters

  name | The name of the parameter to set
  value | String value. Must be in the right format for the type specified in the parameter definition. See the StringConverter class for more information.

Returns
  true if set was successful, false otherwise (NB no exceptions thrown - tolerant method)

Referenced by Ogre::StringInterface::copyParametersTo().

## ◆ setParameterList()

virtual void Ogre::StringInterface::setParameterList | ( | const NameValuePairList & | paramList | ) |
| virtualinherited

Generic multiple parameter setting method.

Remarks
  Call this method with a list of name / value pairs to set. The implementor will convert the string to a native type internally. If in doubt, check the parameter definition in the list returned from StringInterface::getParameters.

Parameters

  paramList | Name/value pair list

## ◆ setParticleVelocity() [1/2]

virtual void Ogre::ParticleEmitter::setParticleVelocity | ( | Real | min,
|  | Real | max
| ) |  |
| virtual

Sets the initial velocity range of particles emitted.

Remarks
  This method sets the range of starting speeds for emitted particles. See the alternate version of this method which takes 1 parameter if you want a constant speed. This emitter will randomly choose a speed between the minimum and maximum for each particle.

Parameters

  max | The maximum speed in world units per second for the initial particle speed on emission.
  min | The minimum speed in world units per second for the initial particle speed on emission.

## ◆ setParticleVelocity() [2/2]

virtual void Ogre::ParticleEmitter::setParticleVelocity | ( | Real | speed | ) |
| virtual

Sets the initial velocity of particles emitted.

Remarks
  This method sets a constant speed for emitted particles. See the alternate version of this method which takes 2 parameters if you want a variable speed.

Parameters

  speed | The initial speed in world units per second which every particle emitted starts with.

## ◆ setPosition()

virtual void Ogre::ParticleEmitter::setPosition | ( | const Vector3 & | pos | ) |
| virtual

Sets the position of this emitter relative to the particle system center.

## ◆ setRepeatDelay() [1/2]

virtual void Ogre::ParticleEmitter::setRepeatDelay | ( | Real | duration | ) |
| virtual

Sets the time between repeats of the emitter.

Remarks
  By default emitters run indefinitely (unless you manually disable them). However, if you manually disable the emitter (by calling setEnabled(false), or it's duration runs out, it will cease to emit

  Also see the alternative version of this method which allows you to set a min and max duration for a random variable duration.

Parameters

  duration | The duration in seconds.

## ◆ setRepeatDelay() [2/2]

virtual void Ogre::ParticleEmitter::setRepeatDelay | ( | Real | min,
|  | Real | max
| ) |  |
| virtual

Sets the range of random duration for this emitter.

Remarks
  By default emitters run indefinitely (unless you manually disable them). By setting this parameter, you can make an emitter turn off on it's own after a random number of seconds. It will then remain disabled until either setEnabled(true) is called, or if the 'repeatAfter' parameter has been set it will also repeat after a number of seconds.

  Also see the alternative version of this method which allows you to set a constant duration.

Parameters

  min | The minimum duration in seconds.
  max | The minimum duration in seconds.

## ◆ setRotation()

void Ogre::Particle::setRotation | ( | const Radian & | rad | ) |
| inherited

Sets the current rotation.

## ◆ setStartTime()

virtual void Ogre::ParticleEmitter::setStartTime | ( | Real | startTime | ) |
| virtual

Sets the 'start time' of this emitter.

Remarks
  By default an emitter starts straight away as soon as a ParticleSystem is first created, or also just after it is re-enabled. This parameter allows you to set a time delay so that the emitter does not 'kick in' until later.

Parameters

  startTime | The time in seconds from the creation or enabling of the emitter.

## ◆ setTimeToLive() [1/2]

virtual void Ogre::ParticleEmitter::setTimeToLive | ( | Real | minTtl,
|  | Real | maxTtl
| ) |  |
| virtual

Sets the range of lifetime for particles emitted.

Remarks
  The emitter initialises particles with a time-to-live (TTL), the number of seconds a particle will exist before being destroyed. This method sets a range for the TTL for all particles emitted; the ttl may be randomised between these 2 extremes or will vary some other way depending on the emitter. Note that affectors are able to modify the TTL of particles later.

  Also see the alternate version of this method which takes a single TTL in order to set a constant TTL for all particles.

Parameters

  minTtl | The minimum number of seconds each particle will live for. Must be non-negative!
  maxTtl | The maximum number of seconds each particle will live for. Must be non-negative!

## ◆ setTimeToLive() [2/2]

virtual void Ogre::ParticleEmitter::setTimeToLive | ( | Real | ttl | ) |
| virtual

Sets the lifetime of all particles emitted.

Remarks
  The emitter initialises particles with a time-to-live (TTL), the number of seconds a particle will exist before being destroyed. This method sets a constant TTL for all particles emitted. Note that affectors are able to modify the TTL of particles later.

  Also see the alternate version of this method which takes a min and max TTL in order to have the TTL vary per particle.

Parameters

  ttl | The number of seconds each particle will live for.

## ◆ setUp()

virtual void Ogre::ParticleEmitter::setUp | ( | const Vector3 & | up | ) |
| virtual

Sets the notional up vector of the emitter.

Remarks
  Many emitters emit particles from within a region, and for some that region is not circularly symmetric about the emitter direction. The up vector allows such emitters to be orientated about the direction vector.

Parameters

  up | The base direction for particles emitted. It must be perpendicular to the direction vector.

## Member Data Documentation

## ◆ mColour

ColourValue Ogre::Particle::mColour
| inherited

Current colour.

## ◆ mHeight

Real Ogre::Particle::mHeight
| inherited

Personal height if mOwnDimensions == true.

## ◆ mOwnDimensions

bool Ogre::Particle::mOwnDimensions
| inherited

Does this particle have it's own dimensions?

## ◆ mParticleType

ParticleType Ogre::Particle::mParticleType
| inherited

Determines the type of particle.

## ◆ mRotation

Radian Ogre::Particle::mRotation
| inherited

Current rotation value.

## ◆ mRotationSpeed

Radian Ogre::Particle::mRotationSpeed
| inherited

Speed of rotation in radians/sec.

## ◆ mTimeToLive

Real Ogre::Particle::mTimeToLive
| inherited

Time to live, number of seconds left of particles natural life.

## ◆ mTotalTimeToLive

Real Ogre::Particle::mTotalTimeToLive
| inherited

Total Time to live, number of seconds of particles natural life.

## ◆ mWidth

Real Ogre::Particle::mWidth
| inherited

Personal width if mOwnDimensions == true.

The documentation for this class was generated from the following file:

- OgreParticleEmitter.h